> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.itential.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.itential.com/_mcp/server.

# Create trigger

POST https://example.itential.io/operations-manager/triggers
Content-Type: application/json

Creates a new Trigger.

Reference: https://docs.itential.com/itential-cloud/api-reference/operations-manager/create-trigger

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object or object or object or any or any.

- `object or object or object or any or any`
  - Endpoint Trigger Create
    - `name` (string, required) — The name of the document
    - `type` (any, required)
    - `routeName` (string, required) — User defined route name.
    - `description` (string, optional) — The description of the document
    - `enabled` (boolean, optional) — A flag to determine if this Trigger is enabled or not.
    - `actionType` (enum, optional) — The type of component this Trigger will invoke.
      - Allowed values: `automations`
    - `actionId` (string, optional) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
    - `options` (object, optional) — Configuration options specific to this trigger.
      - `targetType` (enum, optional, nullable)
        - Allowed values: `instance`, `group`
      - `targetIdentifier` (string, optional, nullable)
      - `chooseTargetAtRuntime` (boolean, optional)
      - `actionId` (string, optional) — A 4-digit hexadecimal id
    - `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
    - `migrationVersion` (integer, optional) — The current document version of this document.
    - `createdBy` (any or string, optional)
    - `created` (string, optional) — An ISO 8601 date string
    - `lastUpdatedBy` (any or string, optional)
    - `lastUpdated` (string, optional) — An ISO 8601 date string
    - `verb` (any, optional)
    - `schema` (object, optional, nullable) — POST body filter schema.
    - `jst` (string, optional, nullable)
  - EventSystem Trigger Create
    - `name` (string, required) — The name of the document
    - `type` (any, required)
    - `topic` (string, required) — The event topic.
    - `description` (string, optional) — The description of the document
    - `enabled` (boolean, optional) — A flag to determine if this Trigger is enabled or not.
    - `actionType` (enum, optional) — The type of component this Trigger will invoke.
      - Allowed values: `automations`
    - `actionId` (string, optional) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
    - `options` (object, optional) — Configuration options specific to this trigger.
      - `targetType` (enum, optional, nullable)
        - Allowed values: `instance`, `group`
      - `targetIdentifier` (string, optional, nullable)
      - `chooseTargetAtRuntime` (boolean, optional)
      - `actionId` (string, optional) — A 4-digit hexadecimal id
    - `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
    - `migrationVersion` (integer, optional) — The current document version of this document.
    - `createdBy` (any or string, optional)
    - `created` (string, optional) — An ISO 8601 date string
    - `lastUpdatedBy` (any or string, optional)
    - `lastUpdated` (string, optional) — An ISO 8601 date string
    - `source` (string, optional) — The source of the event.
    - `schema` (object, optional, nullable) — Event payload filter schema.
    - `legacyWrapper` (boolean, optional) — A boolean determining whether payload data is wrapped in a 'payload' property
    - `jst` (string, optional, nullable)
  - Manual Trigger Create
    - `name` (string, required) — The name of the document
    - `type` (any, required)
    - `description` (string, optional) — The description of the document
    - `enabled` (boolean, optional) — A flag to determine if this Trigger is enabled or not.
    - `actionType` (enum, optional) — The type of component this Trigger will invoke.
      - Allowed values: `automations`
    - `actionId` (string, optional) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
    - `options` (object, optional) — Configuration options specific to this trigger.
      - `targetType` (enum, optional, nullable)
        - Allowed values: `instance`, `group`
      - `targetIdentifier` (string, optional, nullable)
      - `chooseTargetAtRuntime` (boolean, optional)
      - `actionId` (string, optional) — A 4-digit hexadecimal id
    - `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
    - `migrationVersion` (integer, optional) — The current document version of this document.
    - `createdBy` (any or string, optional)
    - `created` (string, optional) — An ISO 8601 date string
    - `lastUpdatedBy` (any or string, optional)
    - `lastUpdated` (string, optional) — An ISO 8601 date string
    - `formData` (object, optional, nullable) — A JSON object created by filling out the associated JSON Form.
    - `formSchemaHash` (string, optional, nullable)
    - `legacyWrapper` (boolean, optional) — A boolean determining whether form data is wrapped in a 'formData' property
    - `formId` (string, optional, nullable) — The id of a JSON Form used to provide inputs to a job from this trigger.

## Response

### 200

The result of the create operation.

- `message` (string, required) — A human-readable message summarizing the result of the operation
- `data` (any, required) — Any successfully retrieved information related to the request.
- `metadata` (map from string to any, required) — Any structured, wordy or machine-readable information related to the result of the operation. For success responses, this may contain information like pagination values from a search operation.

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Examples

**Request**

```json
{
  "name": "Cisco IOS upgrade",
  "routeName": "runSoftwareUpgrade",
  "type": null
}
```

**Response**

```json
{
  "message": "Successfully created the requested item",
  "data": {
    "_id": "string",
    "actionId": "string",
    "actionType": "automations",
    "created": "2024-01-15T09:30:00Z",
    "createdBy": null,
    "description": "Turn up the port",
    "enabled": true,
    "lastExecuted": 1,
    "lastUpdated": "2024-01-15T09:30:00Z",
    "lastUpdatedBy": null,
    "migrationVersion": 1,
    "name": "Cisco IOS upgrade",
    "options": {
      "actionId": "0a2f",
      "chooseTargetAtRuntime": true,
      "targetIdentifier": "string",
      "targetType": "instance"
    }
  },
  "metadata": {}
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/operations-manager/triggers"

payload = {
    "name": "Cisco IOS upgrade",
    "routeName": "runSoftwareUpgrade",
    "type": None
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/operations-manager/triggers';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"name":"Cisco IOS upgrade","routeName":"runSoftwareUpgrade","type":null}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/operations-manager/triggers"

	payload := strings.NewReader("{\n  \"name\": \"Cisco IOS upgrade\",\n  \"routeName\": \"runSoftwareUpgrade\",\n  \"type\": null\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/operations-manager/triggers")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Cisco IOS upgrade\",\n  \"routeName\": \"runSoftwareUpgrade\",\n  \"type\": null\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://example.itential.io/operations-manager/triggers")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Cisco IOS upgrade\",\n  \"routeName\": \"runSoftwareUpgrade\",\n  \"type\": null\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://example.itential.io/operations-manager/triggers', [
  'body' => '{
  "name": "Cisco IOS upgrade",
  "routeName": "runSoftwareUpgrade",
  "type": null
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/operations-manager/triggers");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Cisco IOS upgrade\",\n  \"routeName\": \"runSoftwareUpgrade\",\n  \"type\": null\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [
  "name": "Cisco IOS upgrade",
  "routeName": "runSoftwareUpgrade",
  "type": 
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/operations-manager/triggers")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```